%define major		1
%define libname		%mklibname %{name} %{major}
%define dlibname	%mklibname %{name} -d
%define libacpicaname	%mklibname %{name}acpica %{major}
%define dlibacpicaname	%mklibname %{name}acpica -d
%define libsiaslname	%mklibname %{name}iasl %{major}
%define dlibsiaslname	%mklibname %{name}iasl -d

Name:		fwts
Version:	15.01.00
Release:	%mkrel 2
Summary:	Firmware Test Suite
License:	GPLv2+
Group:		System/Base
URL:		https://wiki.ubuntu.com/FirmwareTestSuite
Source:		http://fwts.ubuntu.com/release/%{name}-V%{version}.tar.gz
BuildRequires:	autoconf
BuildRequires:	automake
BuildRequires:	libtool
BuildRequires:	flex
BuildRequires:	bison
BuildRequires:	mt-st
BuildRequires:	pkgconfig(json-c)
BuildRequires:	pkgconfig(libpcre)
BuildRequires:	pkgconfig(glib-2.0)

#Requires:	pciutils,dmidecode

%description
The tool fwts comprises of over fifty tests that are designed to exercise
and test different aspects of a machine's firmware.
#--------------------------------------------------------------------

%package -n	%{libsiaslname}
Group:		System/Libraries
Summary:	FirmWare Test Suite ACPICA core built for iasl functionality

%description -n	%{libsiaslname}
The firmware test suite requires the ACPICA core engine to be built in compiler
mode (with ACPI_ASL_COMPILER enabled) to support assembly and disassembly of
ACPI Machine Language (AML) in the ACPI DSDT and SSDTs.
This library contains this code with a thin fwts specific API to interface with fwts.

%package -n	%{dlibsiaslname}
Group:		Development/C
Summary:	Devel librairies and headers for FirmWare Test Suite ACPICA core built for iasl functionality
Requires:	%{libsiaslname} = %{version}-%{release}
Requires:	%{dlibname} = %{version}-%{release}
Provides:	%{name}iasl-devel = %{version}-%{release}
Provides:	lib%{name}iasl-devel = %{version}-%{release}

%description -n	%{dlibsiaslname}
The firmware test suite requires the ACPICA core engine to be built in compiler
mode (with ACPI_ASL_COMPILER enabled) to support assembly and disassembly of
ACPI Machine Language (AML) in the ACPI DSDT and SSDTs.
This library contains this code with a thin fwts specific API to interface with
fwts and provides Devel librairies and headers.

%package -n	%{libacpicaname}
Group:		System/Libraries
Summary:	FirmWare Test Suite ACPICA core built for acpiexec functionality

%description -n	%{libacpicaname}
The firmware test suite requires the ACPICA core engine to be built in execution
mode (with ACPI_EXEC_APP enabled) to support run time execution of ACPI Machine
Language (AML) in the ACPI DSDT and SSDTs. This library contains this code with
a thin fwts specific API to interface with fwts.

%package -n	%{dlibacpicaname}
Group:		Development/C
Summary:	Devel librairies and headers for FirmWare Test Suite ACPICA core built for acpiexec functionality
Requires:	%{libacpicaname} = %{version}-%{release}
Requires:	%{dlibname} = %{version}-%{release}
Provides:	%{name}acpica-devel = %{version}-%{release}
Provides:	lib%{name}acpica-devel = %{version}-%{release}

%description -n	%{dlibacpicaname}
The firmware test suite requires the ACPICA core engine to be built in execution
mode (with ACPI_EXEC_APP enabled) to support run time execution of ACPI Machine
Language (AML) in the ACPI DSDT and SSDTs. This library contains this code with
a thin fwts specific API to interface with fwts and provides Devel librairies
and headers.

%package -n	%{libname}
Group:		System/Libraries
Summary:	FirmWare Test Suite core support library

%description -n	%{libname}
This is the fwts core library. It contains a top level test framework and a rich
range of firmware specific testing support code for the various fwts tests.

%package -n	%{dlibname}
Group:		Development/C
Summary:	Devel librairies and headers for FirmWare Test Suite core support library
Requires:	%{libname} = %{version}-%{release}
Provides:	%{name}-devel = %{version}-%{release}
Provides:	lib%{name}-devel = %{version}-%{release}

Obsoletes:	%{_lib}fwts1-devel < 15.01.00-2

%description -n	%{dlibname}
This is the fwts core library. It contains a top level test framework and a rich
range of firmware specific testing support code for the various fwts tests and
provides Devel librairies and headers.

#package -n	%%{name}-frontend
#Requires:	fwts,dialog
#Group:		Development/C
#Summary:	Firmware Test Suite frontend interface

#description -n	%%{name}-frontend
#This is a dialog based interface designed to provide an easy to use method to
#execute tests via Firmware Test Suite and is also used as the primary interface
#within Firmware Test Suite live images.

%package -n	%{name}-efi-runtime-dkms
Requires:	dkms
Group:		Development/C
Summary:	Firmware Test Suite frontend interface

%description -n	%{name}-efi-runtime-dkms
This is a dialog based interface designed to provide an easy to use method to
execute tests via Firmware Test Suite and is also used as the primary interface
within Firmware Test Suite live images.

%prep
%setup -q -c -n %{name}-%{version}
# Mageia json includes are in another subdir
# Not done as a patch to allow for changes upstream
find . -name '*.c' -o -name '*.h' | xargs perl -pi -e 's|#include <json/json.h>|#include <json-c/json.h>|'
perl -pi -e 's|json/json.h|json-c/json.h|' configure.ac
perl -pi -e 's|<json.h>|<json-c/json.h>|' src/lib/include/fwts_json.h src/utilities/kernelscan.c

%build
%define _disable_ld_no_undefined 1
export DESTDIR=%{_prefix}

autoreconf -ivf
# Do not use %%configure2_5x macros here it breaks the build
#./configure
./configure --prefix=%{_prefix} --libdir=%{_libdir} --disable-static
make

%install
%makeinstall_std
find %{buildroot} -type f -name "*.la" -print -delete
#install -D -m 0644 data/klog.json %%{buildroot}%%{_datadir}/%%{name}/klog.json
#install -D -m 0644 data/syntaxcheck.json %%{buildroot}%%{_datadir}/%%{name}/syntaxcheck.json
mkdir -p %{buildroot}%{_usrsrc}/%{name}-efi-runtime-dkms-%{version}
cp -a efi_runtime/* %{buildroot}%{_usrsrc}/%{name}-efi-runtime-dkms-%{version}
# lib are delivered in a subdir by default
mv %{buildroot}%{_libdir}/%{name}/* %{buildroot}/%{_libdir}
rmdir %{buildroot}%{_libdir}/%{name}
# we don't deliver frontend for now
rm -f %{buildroot}%{_mandir}/man1/%{name}-frontend-text.*
mkdir -p %{buildroot}%{_includedir}
mv src/lib/include/*.h %{buildroot}%{_includedir}

%post -n %{name}-efi-runtime-dkms
dkms add -m %{name}-efi-runtime-dkms -v %{version} --rpm_safe_upgrade

%preun -n %{name}-efi-runtime-dkms
dkms remove -m %{name}-efi-runtime-dkms -v %{version} --all --rpm_safe_upgrade

%files
%doc README*
%dir %{_datadir}/%{name}
%{_datadir}/%{name}/*.json
%{_bindir}/%{name}
%{_bindir}/kernelscan
%{_mandir}/man1/%{name}.1.*
%{_mandir}/man1/%{name}-collect.1.*

%files -n %{libname}
%{_libdir}/lib%{name}.so.%{major}
%{_libdir}/lib%{name}.so.%{major}.*

%files -n %{dlibname}
%{_includedir}/fwts*.h
%{_libdir}/lib%{name}.so

%files -n %{libsiaslname}
%{_libdir}/lib%{name}iasl.so.%{major}
%{_libdir}/lib%{name}iasl.so.%{major}.*

%files -n %{dlibsiaslname}
%{_libdir}/lib%{name}iasl.so

%files -n %{libacpicaname}
%{_libdir}/lib%{name}acpica.so.%{major}
%{_libdir}/lib%{name}acpica.so.%{major}.*

%files -n %{dlibacpicaname}
%{_libdir}/lib%{name}acpica.so

#files -n %%{name}-frontend
#{_bindir}/%%{name}-frontend-text
#{_datadir}/%%{name}/fwts-live-dialogrc
#{_mandir}/man1/%%{name}-frontend-text.1.*

%files -n %{name}-efi-runtime-dkms
%{_usrsrc}/%{name}-efi-runtime-dkms-%{version}


%changelog
* Thu Jan 29 2015 bcornec <bcornec> 15.01.00-2.mga5
+ Revision: 812690
- Apply patch from David GEIGER <geiger.david68210_at_gmail.com> to fix libraries management

* Sat Jan 24 2015 bcornec <bcornec> 15.01.00-1.mga5
+ Revision: 812147
- Update to upstream 15.00.01
- Update sha1 file as well :-(
- Updated to upstream 14.12.00

* Sat Nov 22 2014 bcornec <bcornec> 14.11.00-1.mga5
+ Revision: 798252
- Update to upstream 14.11.00

* Wed Oct 15 2014 umeabot <umeabot> 14.09.00-2.mga5
+ Revision: 741132
- Second Mageia 5 Mass Rebuild

* Wed Sep 24 2014 bcornec <bcornec> 14.09.00-1.mga5
+ Revision: 723682
- update to upstream 14.09.00

* Tue Sep 16 2014 umeabot <umeabot> 14.08.00-2.mga5
+ Revision: 679391
- Mageia 5 Mass Rebuild

* Thu Sep 11 2014 bcornec <bcornec> 14.08.00-1.mga5
+ Revision: 674689
- Improv build and install requires
- Fix a description missing for the main pkg
- Adds a missing sha1
- Import fwts inspired by the debian pkg
- Created package structure for fwts.

